Bug 873241

Summary: Create Python 3 packages
Product: [Fedora] Fedora Reporter: Joanmarie Diggs <jdiggs>
Component: brlttyAssignee: Gwyn Ciesla <limburgher>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 19CC: jskarvad, kalevlember, limburgher
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-04-20 15:35:21 EDT Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 914972    

Description Joanmarie Diggs 2012-11-05 07:22:26 EST
There is a GNOME Goal to migrate to Python 3 [1] which has just been approved by the Release Team for GNOME 3.8 [2]. Because brltty and brlapi are Orca dependencies, it would be extremely helpful to have Python 3 packages.

Notes:

1. The porting has mostly been done as I understand it. They are, however, trying to maintain Python 2 + Python 3 compatibility, so it is necessary to specify Python 3 when building.

2. I am now testing and submitting patches to them where appropriate (e.g. [3]) and making changes in Orca where needed. So things are a tad "under construction" at this moment, but I hope to have these issues sorted out within the next couple of weeks (at the most).

Thanks in advance!

[1] https://live.gnome.org/GnomeGoals/Python3Porting
[2] https://mail.gnome.org/archives/distributor-list/2012-November/msg00000.html
[3] http://mielke.cc/pipermail/brltty/2012-November/009624.html
Comment 1 Gwyn Ciesla 2012-11-05 09:26:26 EST
So are you envisioning a python3-brlapi, or moving python-brlapi to Python 3?
Comment 2 Joanmarie Diggs 2012-11-08 08:53:20 EST
Hmmmm. Good question.

Unlike other packages, my *guess* is that other than Orca there are not too many (any??) Python applications in Fedora which need brlapi. Having said that, I would feel really awful if I said "just move it to Python 3" and later found out that statement broke braille support for some use case I hadn't known about.

I also know *nothing* about how much effort goes into maintaining packages. If it's not a lot of work to have both Python 2 and Python 3 versions, I think that would be the way to go. If, on the other hand, it is a lot of work, then I can ask on the brltty list if there is indeed a use case that requires keeping Python 2's packages.
Comment 3 Gwyn Ciesla 2012-11-08 10:52:07 EST
repoquery only indicates orca as needing python-brlapi, but it's probably best to make a python3-brlapi just in case.  I'll look into it.
Comment 4 Gwyn Ciesla 2012-11-08 10:58:14 EST
I'm actually dissuaded from doing this until the patch is upstream, what's the timeline there?

https://fedoraproject.org/wiki/Packaging:Python#Subpackages
Comment 5 Joanmarie Diggs 2012-11-08 12:24:53 EST
Upstream stable you mean? If so, I can ask when the next release will be.

The project lead already committed it for unstable:
http://mielke.cc/pipermail/brltty/2012-November/009626.html
Comment 6 Joanmarie Diggs 2012-11-08 12:26:39 EST
I should add that, so far, nothing else has been found that needs to be patched in brltty/brlapi though I keep testing (I use F18).
Comment 7 Gwyn Ciesla 2012-11-08 14:10:34 EST
Ok.  I also can't get 4.4 to build, so maybe I should wait for the next release.
Comment 8 Kalev Lember 2013-02-23 15:34:41 EST
I can help if you need a hand with getting things building.

The Alpha Change Deadline is on 2013-04-02, would be great to have a working Python 3 version of Orca by that time. Otherwise we'd have to ship live media without a working screenreader.
Comment 9 Joanmarie Diggs 2013-02-23 15:55:06 EST
I've pinged Dave (brltty) maintainer for a stable package. He hopes to have one soon.

In the meantime, because I use Fedora as my development environment, I do know it is possible to build brltty/brlapi from master in an F18 environment and have it work with Orca.

1. Install Cython (before it was using Pyrex I believe).
2. Run autogen
3. Run configure as PYTHON=/usr/bin/python3 configure --prefix=....
Comment 10 Kalev Lember 2013-03-20 17:31:34 EDT
We're still missing the new release. Joanmarie said she'd ping the upstream maintainer again; let's see how it goes.

In the meantime, can I offer help to move things along? I could build a snapshot of the latest svn, seems to build fine locally.
Comment 11 Joanmarie Diggs 2013-03-20 17:41:32 EDT
I just begged and pleaded. http://mielke.cc/pipermail/brltty/2013-March/009940.html. Cross your fingers.
Comment 12 Joanmarie Diggs 2013-03-22 00:36:09 EDT
Is 1 April soon enough? http://mielke.cc/pipermail/brltty/2013-March/009954.html
Comment 13 Fedora End Of Life 2013-04-03 15:31:23 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 14 Joanmarie Diggs 2013-04-03 18:59:35 EDT
We have the new stable release: http://mielke.cc/pipermail/brltty/2013-April/010016.html
Comment 15 Kalev Lember 2013-04-04 19:25:33 EDT
Jon was fine with me handling the brltty update, so I've gone ahead and done the builds, for both F19 and rawhide.

I am afraid we've missed the F19 Alpha ship though, the tree is already frozen. The Orca build that's going to be included in the F19 Alpha live media is without brltty support, but otherwise functional. But after the release, the flood gates are going to open again and we'll be able to get the new brltty + Orca builds in.
Comment 16 Fedora Update System 2013-04-04 19:28:04 EDT
brltty-4.5-2.fc19,orca-3.8.0-2.fc19,qemu-1.4.0-11.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/brltty-4.5-2.fc19,orca-3.8.0-2.fc19,qemu-1.4.0-11.fc19
Comment 17 Joanmarie Diggs 2013-04-04 20:20:44 EDT
(In reply to comment #15)
> Jon was fine with me handling the brltty update, so I've gone ahead and done
> the builds, for both F19 and rawhide.
> 
> I am afraid we've missed the F19 Alpha ship though, the tree is already
> frozen. The Orca build that's going to be included in the F19 Alpha live
> media is without brltty support, but otherwise functional. But after the
> release, the flood gates are going to open again and we'll be able to get
> the new brltty + Orca builds in.

I think we can live with it not being in the Alpha release. :) Kalev, you TOTALLY rock!! Thank you for staying on top of this and making it happen.
Comment 18 Fedora Update System 2013-04-04 22:54:51 EDT
Package brltty-4.5-2.fc19, orca-3.8.0-2.fc19, qemu-1.4.0-11.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing brltty-4.5-2.fc19 orca-3.8.0-2.fc19 qemu-1.4.0-11.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-4883/brltty-4.5-2.fc19,orca-3.8.0-2.fc19,qemu-1.4.0-11.fc19
then log in and leave karma (feedback).
Comment 19 Fedora Update System 2013-04-20 15:35:23 EDT
brltty-4.5-2.fc19, orca-3.8.0-2.fc19, qemu-1.4.0-11.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.